<template>
  <div class="app-container">
    <!-- 项目立项 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="90px"
      label-position="top">
      <el-row :gutter="20">
        <el-col :span="6">
          <el-form-item label="项目名称" prop="projectName">
            <el-input v-model.trim="queryParams.projectName" placeholder="请输入项目名称" clearable
              @keyup.enter.native="handleQuery" />
          </el-form-item>
        </el-col>
        <el-col :span="6">
          <el-form-item label="项目负责人" prop="investHead">
            <el-input v-model.trim="queryParams.investHead" placeholder="请输入项目负责人" clearable
              @keyup.enter.native="handleQuery" />
          </el-form-item>
        </el-col>
        <el-col :span="6">
          <el-form-item label="公司联系人" prop="projectContacts">
            <el-input v-model.trim="queryParams.projectContacts" placeholder="请输入公司联系人" clearable
              @keyup.enter.native="handleQuery" />
          </el-form-item>
        </el-col>
        <el-col :span="6">
          <el-form-item label="渠道" prop="channel">
            <el-select v-model="queryParams.channel" placeholder="全部" clearable style="width: 100%;">
              <el-option v-for="item in channelList" :key="item.id" :label="item.channelName" :value="item.id" />
              <el-option label="直接触达" value="1" />
              <el-option label="内部推荐" value="2" />
            </el-select>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="20">
        <el-col :span="6">
          <el-form-item label="所属组别" prop="projectGroup">
            <el-select v-model="queryParams.projectGroup" placeholder="全部" clearable style="width: 100%;">
              <el-option v-for="dict in dict.type.project_group" :key="dict.value" :label="dict.label"
                :value="dict.value" />
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="6">
          <el-form-item label="项目公司" prop="company">
            <el-input v-model.trim="queryParams.company" placeholder="请输入项目所属公司" clearable
              @keyup.enter.native="handleQuery" />
          </el-form-item>
        </el-col>
        <el-col :span="6"></el-col>
        <el-col :span="6"></el-col>
      </el-row>






      <!-- 可继续扩展其他查询表单项目，比如项目编号、负责人等 -->
      <el-row :gutter="20">
        <el-col :span="6">
          <el-form-item label="搜索">
            <el-button style="width: 100%;" type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
          </el-form-item>
        </el-col>
        <el-col :span="6">
          <el-form-item label="重置">
            <el-button style="width: 100%;" icon="el-icon-refresh" type="primary" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="warning" size="small" icon="el-icon-document" @click="handleAdd">立项申请</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" icon="el-icon-download" size="small" @click="handleExport">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
    <div class="border-card">
      <el-table height="450" ref="dataTable" @row-click="clickRow" class="tableWrapper" v-loading="loading" border :data="poolList"
        @selection-change="handleSelectionChange">
        <!--      <el-table-column type="selection" width="40" align="center" />-->
        <el-table-column type="index" label="序号" width="50" align="center"></el-table-column>
        <!-- <el-table-column label="主键id" align="center" prop="id" /> -->
        <el-table-column label="项目名称" align="center" prop="projectName">
          <template slot-scope="scope">
            <div :title="scope.row.projectName" class="public-text-blue public-cursor"
              @click.stop="handleDetail(scope.row)">
              {{ scope.row.projectName }}
            </div>
          </template>
        </el-table-column>
        <el-table-column label="公司名称" align="center" prop="tProjectCompany.companyName">
          <template slot-scope="scope">
            <div :title="scope.row.tProjectCompany.companyName">
              {{ scope.row.tProjectCompany.companyName }}
            </div>
          </template>
        </el-table-column>
        <el-table-column label="所属行业" align="center" prop="industry"><template slot-scope="scope">
            <dict-tag :options="dict.type.CUSTOMER_TRADE" :value="scope.row.industry" />
          </template>
        </el-table-column>
        <el-table-column label="项目阶段" align="center" prop="projectStage">
          <template slot-scope="scope">
            <dict-tag :options="dict.type.project_stage" :value="scope.row.projectStage" />
          </template>
        </el-table-column>
        <el-table-column label="项目机会状态" align="center" prop="projectStatus">
          <template slot-scope="scope">
            <!-- 定义状态文本映射对象 -->
            <el-tag :type="{
              0: 'success',
              1: 'danger',
              2: 'warning'
            }[scope.row.projectStatus] || 'info'">
              {{ {
                0: '正常',
                1: '终止',
                2: '观望'
              }[scope.row.projectStatus] || '未知状态' }}
            </el-tag>
          </template>
        </el-table-column>
        <el-table-column label="备案时间" align="center" prop="tProjectCompany.filingTime">
          <template slot-scope="scope">
            <span>{{
              parseTime(scope.row.tProjectCompany.filingTime, "{y}-{m}-{d}")
              }}</span>
          </template>
        </el-table-column>
        <el-table-column label="立项通过日期" align="center" prop="projectDate">
          <template slot-scope="scope">
            <span>{{ parseTime(scope.row.projectDate, "{y}-{m}-{d}") }}</span>
          </template>
        </el-table-column>
        <el-table-column label="已发起立项申请" align="center" prop="approvalFlag">
          <template slot-scope="scope">
            <div>
              {{ scope.row.approvalFlag === "1" ? "是" : "否" }}
            </div>
          </template>
        </el-table-column>
        <el-table-column label="项目负责人" align="center" prop="investHead">
          <template slot-scope="scope">
            <div :title="scope.row.investHead">
              {{ scope.row.investHead }}
            </div>
          </template>
        </el-table-column>
        <!-- <el-table-column label="项目编号" align="center" prop="projectCode" /> -->
        <el-table-column label="渠道" align="center" prop="tProjectChannel.channelName">
          <template slot-scope="scope">
            <div v-if="
              scope.row.tProjectChannel && scope.row.tProjectChannel.channelName
            " :title="scope.row.tProjectChannel.channelName">
              {{ scope.row.tProjectChannel.channelName }}
            </div>
            <div v-else-if="scope.row.channel == '1'">
              直接触达
            </div>
            <div v-else="scope.row.channel=='2'">
              内部推荐
            </div>
          </template>
        </el-table-column>
        <!-- delFlag -->
        <el-table-column label="状态" align="center" prop="investHead" width="50px">
          <template slot-scope="scope">
            <div :title="scope.row.delFlag === '1' ? '终止' : '正常'">
              {{ scope.row.delFlag === "1" ? "终止" : "正常" }}
            </div>
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
        @pagination="getList" />
    </div>



    <!-- 会议管理组件 -->
    <meetingList :type="'3'" ref="meetingList" :projectId="projectId" @getList="getList"></meetingList>
    <!-- 设置项目状态对话框 -->
    <businessUpdate @getList="getList" ref="businessUpdate"></businessUpdate>
  </div>
</template>

<script>
import { listApprovalStage, } from "@/api/project/pool";
import { listChannel } from "@/api/invest/channel";
import meetingList from "../meetingList";
import businessUpdate from "../../invest/components/businessUpdate.vue";
import { mapGetters } from "vuex";
export default {
  name: "Pool3",
  dicts: ["project_group", "project_stage", "project_state", "CUSTOMER_TRADE"],
  components: {
    meetingList,
    businessUpdate,
  },
  data() {
    return {
      // 遮罩层
      loading: false,

      // 选中id数组
      ids: [],
      idsName: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 选中数组
      selectRowList: [],
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 项目池表格数据
      poolList: [],
      // 查询参数
      queryParams: {
        id: null,
        pageNum: 1,
        pageSize: 10,
        projectName: null,
        projectGroup: "",
        projectCode: null,
        channel: null,
        contactDate: null,
        projectDate: null,
        decisionDate: null,
        industry: null,
        company: null,
        projectContacts: null,
        investHead: null,
        previousFinancing: null,
        financingStage: null,
        financingMoney: null,
        financingDate: null,
        investValuation: null,
        investMoney: null,
        investType: null,
        investPloy: null,
        investWorth: null,
        projectStage: null,
        projectState: null,
        orderByColumn: "createTime",
        isAsc: "desc",
        createTime: null,
      },
      channelList: [],

      projectId: "",
    };
  },
  computed: {
    ...mapGetters(["user"]),
  },
  created() { },
  mounted() {
    this.getList();
    // 渠道
    listChannel({
      pageNum: 1,
      pageSize: 100,
    }).then((response) => {
      this.channelList = response.rows;
    });
  },
  methods: {
    /** 查询项目立项阶段列表 */
    getList() {
      this.loading = true;
      listApprovalStage(this.queryParams).then((response) => {
        this.poolList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.queryParams.orderByColumn = "createTime";
      this.queryParams.isAsc = "desc";
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      if (selection.length > 1) {
        //移除上一次选中行数据
        selection.shift();
        //修改选中图标为未选中状态
        this.$refs.dataTable.clearSelection();
        //将当前选中行改为选中状态
        this.$refs.dataTable.toggleRowSelection(selection[0]);
      }
      this.idsName = selection.map((item) => item.projectName);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
      this.selectRowList = selection;
    },

    clickRow(row) {
      this.$refs.dataTable.toggleRowSelection(row);
    },
    /** 新增按钮操作 */
    handleAdd() {
      // 立项申请
      this.$refs.meetingList.showLXApplyPop();
    },
    handleSelectData(type, otherData) {
      // type 1=修改 2=详情 3=设置项目阶段 4=终止 5=上传评估意见
      // 6=立项申请 7=发起立项会议 8=上传打分表（立项）
      // 9=尽调申请 10=上传尽调报告
      // 11=投决申请 12=发起投决会议 13=上传打分表（投决）
      if (this.selectRowList.length == 1) {
        const row = this.selectRowList[0];
        // 1.单条数据 2.项目是否终止  3.是否能操作
        if (row.delFlag === "1") {
          this.$message({
            message: "项目已终止",
            duration: 1500,
            type: "error",
          });
        } else if (type === 8) {
          // 有立项会议
          if (row.tProjectMeeting) {
            // 参与人
            if (
              row.tProjectMeeting.participants.indexOf(this.user.nickName) > -1
            ) {
              // 是否打过分
              if (row.tProjectScoring) {
                this.$message.warning("您已打分,无需重复操作");
              } else {
                // 立项-去打分
                this.$refs.meetingList.handleMark(row.tProjectMeeting, "1", false);
              }
            } else {
              this.$message.warning("无权限");
            }
          } else {
            if (row.investHead === this.user.nickName) {
              this.$message({
                message: "请先发起立项会议",
                duration: 1500,
                type: "warning",
              });
            } else {
              this.$message.warning("无权限");
            }
          }
        } else if (row.investHead === this.user.nickName) {
          // 项目负责人
          if (type === 2) {
            // 详情
            this.handleDetail(row);
          } else if (type === 3) {
            // 设置项目阶段
            this.$refs.businessUpdate.handleBusinessUpdate(row);
          } else if (type === 4) {
            this.handleDelete(row);
          } else if (type === 6) {
            if (row.approvalFlag === "0") {
              // 立项申请
              this.$refs.meetingList.showLXApplyPop(row);
            } else {
              this.$message({
                message: "您已发起立项申请,无需重复操作",
                duration: 1500,
                type: "warning",
              });
            }
          } else if (type === 7) {
            if (row.approvalFlag === "1") {
              // 发起立项会议
              this.handleMeeting(row, otherData);
            } else {
              this.$message({
                message: "请先立项申请",
                duration: 1500,
                type: "warning",
              });
            }
          }
        } else {
          this.$message({
            message: "无权限",
            duration: 1500,
            type: "error",
          });
        }
      } else {
        this.$message({
          message: "只能选择一条数据",
          duration: 1500,
          type: "warning",
        });
      }
    },
    handleDetail(row) {
      const id = row.id || this.ids;
      this.$router.push({ path: "/stage/project/poolDetail", query: { id: id } });
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      const id = row.id;
      this.$router.push({ path: "/invest/pool/add", query: { id: id } });
    },
    // 发起会议
    handleMeeting(row, meetingType) {
      this.$store.commit("SET_PROJECTITEMMESSAGE", row);
      this.$refs.meetingList.handleAdd(row.id, meetingType);
    },
    /**终止按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      const idsName = row.projectName ? row.projectName : this.idsName;
      this.$modal
        .confirm('是否终止"' + idsName + '"项目？')
        .then(function () {
          return delPool(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("已终止");
        })
        .catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "project/exportApprovalStage",
        {
          ...this.queryParams,
        },
        `approvalStage_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
<style lang="scss" scoped>


.tableWrapper {
  font-size: 12px;
  color: #000;

  ::v-deep .el-table__header-wrapper th {
    font-size: 12px;
    font-weight: bolder;
    color: #000;
  }

  ::v-deep td.el-table__cell:not(:last-child) div {
    text-overflow: -o-ellipsis-lastline;
    overflow: hidden;
    text-overflow: ellipsis;
    display: -webkit-box;
    -webkit-line-clamp: 1;
    line-clamp: 1;
    -webkit-box-orient: vertical;
  }
}

/**找到表头那一行，然后把里面的复选框隐藏掉**/
.tableWrapper::v-deep .el-table__header-wrapper .el-table__header .el-checkbox {
  display: none;
}
</style>
